
#include <windows.h>
#include <winuser.h>
#include "resource.h"

#define LineHeight		20

const TCHAR szAppName[] = TEXT("CRT EDID");
HINSTANCE hInst;

typedef struct tagVIACRTEDID
{
    BYTE     Reg[19];
}VIACRTEDID, NEAR* PVIACRTEDID, FAR* LPVIACRTEDID;

typedef struct tagDisplayRes
{
    int		XRes;
	int		YRes;
	int		Refresh;
}DISPLAYRES;

VIACRTEDID	ViaEDID;
DISPLAYRES	ViaDisplayRes[32];
int			iDisplayNum;
BOOL		bIsEDIDExist;

// Dialog Message Process Callback Function
BOOL CALLBACK MainDialog(HWND, UINT, WPARAM, LPARAM);

void HandleMainDialogCommand(HWND hWnd, WPARAM wParam, LPARAM lParam);

void SelectDisplayMode(HWND hWnd, UINT iMode);


int WINAPI WinMain(HINSTANCE hInstance, HINSTANCE hPrevInstance, LPWSTR lpCmdLine, int nCmdShow)
{
    return DialogBox(hInstance, MAKEINTRESOURCE(IDD_DlgSetMode), NULL, MainDialog);
}


BOOL GetEDIDTable(LPVIACRTEDID lpViaEDID)
{
	HDC		hDc;
	int		iRetVal;
	DWORD	dwInBuffer[1];

	//return TRUE;
	hDc = CreateDC(TEXT("DISPLAY"), NULL, NULL, NULL);

	dwInBuffer[0] = 0X4101;
	// Make the escape call to see if queryescape is supported.

	iRetVal = ExtEscape(hDc, 0X4101,
						sizeof(dwInBuffer),
						(LPCSTR)dwInBuffer,
						sizeof(*lpViaEDID),
						(LPSTR)lpViaEDID);
	DeleteDC(hDc);

	if (iRetVal != 1)
		return FALSE;
	return TRUE;
}

void TranEDIDtoDisplay(void)
{
	BYTE	bTmp;
	int i;

	iDisplayNum = 0;

	if (ViaEDID.Reg[0] & 0x80)
	{
		ViaDisplayRes[iDisplayNum].XRes = 720;
		ViaDisplayRes[iDisplayNum].YRes = 400;
		ViaDisplayRes[iDisplayNum].Refresh = 70;
		iDisplayNum++;
	}
	if (ViaEDID.Reg[0] & 0x40)
	{
		ViaDisplayRes[iDisplayNum].XRes = 720;
		ViaDisplayRes[iDisplayNum].YRes = 400;
		ViaDisplayRes[iDisplayNum].Refresh = 88;
		iDisplayNum++;
	}
	if (ViaEDID.Reg[0] & 0x20)
	{
		ViaDisplayRes[iDisplayNum].XRes = 640;
		ViaDisplayRes[iDisplayNum].YRes = 480;
		ViaDisplayRes[iDisplayNum].Refresh = 60;
		iDisplayNum++;
	}
	if (ViaEDID.Reg[0] & 0x10)
	{
		ViaDisplayRes[iDisplayNum].XRes = 640;
		ViaDisplayRes[iDisplayNum].YRes = 480;
		ViaDisplayRes[iDisplayNum].Refresh = 67;
		iDisplayNum++;
	}
	if (ViaEDID.Reg[0] & 0x08)
	{
		ViaDisplayRes[iDisplayNum].XRes = 640;
		ViaDisplayRes[iDisplayNum].YRes = 480;
		ViaDisplayRes[iDisplayNum].Refresh = 72;
		iDisplayNum++;
	}
	if (ViaEDID.Reg[0] & 0x04)
	{
		ViaDisplayRes[iDisplayNum].XRes = 640;
		ViaDisplayRes[iDisplayNum].YRes = 480;
		ViaDisplayRes[iDisplayNum].Refresh = 75;
		iDisplayNum++;
	}
	if (ViaEDID.Reg[0] & 0x02)
	{
		ViaDisplayRes[iDisplayNum].XRes = 800;
		ViaDisplayRes[iDisplayNum].YRes = 600;
		ViaDisplayRes[iDisplayNum].Refresh = 56;
		iDisplayNum++;
	}
	if (ViaEDID.Reg[0] & 0x01)
	{
		ViaDisplayRes[iDisplayNum].XRes = 800;
		ViaDisplayRes[iDisplayNum].YRes = 600;
		ViaDisplayRes[iDisplayNum].Refresh = 60;
		iDisplayNum++;
	}
	if (ViaEDID.Reg[1] & 0x80)
	{
		ViaDisplayRes[iDisplayNum].XRes = 800;
		ViaDisplayRes[iDisplayNum].YRes = 600;
		ViaDisplayRes[iDisplayNum].Refresh = 72;
		iDisplayNum++;
	}
	if (ViaEDID.Reg[1] & 0x40)
	{
		ViaDisplayRes[iDisplayNum].XRes = 800;
		ViaDisplayRes[iDisplayNum].YRes = 600;
		ViaDisplayRes[iDisplayNum].Refresh = 75;
		iDisplayNum++;
	}
	if (ViaEDID.Reg[1] & 0x20)
	{
		ViaDisplayRes[iDisplayNum].XRes = 832;
		ViaDisplayRes[iDisplayNum].YRes = 624;
		ViaDisplayRes[iDisplayNum].Refresh = 75;
		iDisplayNum++;
	}
	if (ViaEDID.Reg[1] & 0x10)
	{
		ViaDisplayRes[iDisplayNum].XRes = 1024;
		ViaDisplayRes[iDisplayNum].YRes = 768;
		ViaDisplayRes[iDisplayNum].Refresh = 87;
		iDisplayNum++;
	}
	if (ViaEDID.Reg[1] & 0x08)
	{
		ViaDisplayRes[iDisplayNum].XRes = 1024;
		ViaDisplayRes[iDisplayNum].YRes = 768;
		ViaDisplayRes[iDisplayNum].Refresh = 60;
		iDisplayNum++;
	}
	if (ViaEDID.Reg[1] & 0x04)
	{
		ViaDisplayRes[iDisplayNum].XRes = 1024;
		ViaDisplayRes[iDisplayNum].YRes = 768;
		ViaDisplayRes[iDisplayNum].Refresh = 70;
		iDisplayNum++;
	}
	if (ViaEDID.Reg[1] & 0x02)
	{
		ViaDisplayRes[iDisplayNum].XRes = 1024;
		ViaDisplayRes[iDisplayNum].YRes = 768;
		ViaDisplayRes[iDisplayNum].Refresh = 75;
		iDisplayNum++;
	}
	if (ViaEDID.Reg[1] & 0x01)
	{
		ViaDisplayRes[iDisplayNum].XRes = 1280;
		ViaDisplayRes[iDisplayNum].YRes = 1024;
		ViaDisplayRes[iDisplayNum].Refresh = 75;
		iDisplayNum++;
	}
	if (ViaEDID.Reg[2] & 0x80)
	{
		ViaDisplayRes[iDisplayNum].XRes = 1152;
		ViaDisplayRes[iDisplayNum].YRes = 870;
		ViaDisplayRes[iDisplayNum].Refresh = 75;
		iDisplayNum++;
	}
	/*
	if (ViaEDID.Reg[2] & 0x40)
	{
		ViaDisplayRes[iDisplayNum].XRes = 168;
		ViaDisplayRes[iDisplayNum].YRes = 168;
		ViaDisplayRes[iDisplayNum].Refresh = 168;
		iDisplayNum++;
	}
	if (ViaEDID.Reg[2] & 0x20)
	{
		ViaDisplayRes[iDisplayNum].XRes = 168;
		ViaDisplayRes[iDisplayNum].YRes = 168;
		ViaDisplayRes[iDisplayNum].Refresh = 168;
		iDisplayNum++;
	}
	if (ViaEDID.Reg[2] & 0x10)
	{
		ViaDisplayRes[iDisplayNum].XRes = 168;
		ViaDisplayRes[iDisplayNum].YRes = 168;
		ViaDisplayRes[iDisplayNum].Refresh = 168;
		iDisplayNum++;
	}
	if (ViaEDID.Reg[2] & 0x08)
	{
		ViaDisplayRes[iDisplayNum].XRes = 168;
		ViaDisplayRes[iDisplayNum].YRes = 168;
		ViaDisplayRes[iDisplayNum].Refresh = 168;
		iDisplayNum++;
	}
	if (ViaEDID.Reg[2] & 0x04)
	{
		ViaDisplayRes[iDisplayNum].XRes = 168;
		ViaDisplayRes[iDisplayNum].YRes = 168;
		ViaDisplayRes[iDisplayNum].Refresh = 168;
		iDisplayNum++;
	}
	if (ViaEDID.Reg[2] & 0x02)
	{
		ViaDisplayRes[iDisplayNum].XRes = 168;
		ViaDisplayRes[iDisplayNum].YRes = 168;
		ViaDisplayRes[iDisplayNum].Refresh = 168;
		iDisplayNum++;
	}
	if (ViaEDID.Reg[2] & 0x01)
	{
		ViaDisplayRes[iDisplayNum].XRes = 168;
		ViaDisplayRes[iDisplayNum].YRes = 168;
		ViaDisplayRes[iDisplayNum].Refresh = 168;
		iDisplayNum++;
	}*/

	for(i=3; i<19; i++)
	{
		if (ViaEDID.Reg[i] != 0x0)
		{
			ViaDisplayRes[iDisplayNum].XRes = (ViaEDID.Reg[i] + 31) * 8;
			i++;
			bTmp = (ViaEDID.Reg[i] & 0xc0) >> 6;
			if (bTmp == 0x0)
				ViaDisplayRes[iDisplayNum].YRes = ViaDisplayRes[iDisplayNum].XRes / 16 * 10;
			else if (bTmp == 0x1)
				ViaDisplayRes[iDisplayNum].YRes = ViaDisplayRes[iDisplayNum].XRes / 4 * 3;
			else if (bTmp == 0x2)
				ViaDisplayRes[iDisplayNum].YRes = ViaDisplayRes[iDisplayNum].XRes / 5 * 4;
			else
				ViaDisplayRes[iDisplayNum].YRes = ViaDisplayRes[iDisplayNum].XRes / 16 * 9;

			bTmp = ViaEDID.Reg[i] & 0x3f;
			ViaDisplayRes[iDisplayNum].Refresh = (int)bTmp + 60;
			iDisplayNum++;
		}
		else
		{
			break;
		}
	}
}

void InitMainDialog(HWND hWnd)
{
	if (GetEDIDTable(&ViaEDID))
	{
		TranEDIDtoDisplay();
		bIsEDIDExist = TRUE;
	}
	else
	{
		bIsEDIDExist = FALSE;
	}
}

void DoPaintMain (HWND hWnd, UINT wMsg, WPARAM wParam, LPARAM lParam)
{
    PAINTSTRUCT ps;
    RECT rect;
    HDC hdc;
	int i;
	TCHAR szString[128];

    GetClientRect (hWnd, &rect);
	rect.left += LineHeight;
	//rect.top += LineHeight;

    hdc = BeginPaint (hWnd, &ps); 
    //DrawText (hdc, TEXT ("CJ Loves You!"), -1, &rect, DT_SINGLELINE);

	for (i=0; i<iDisplayNum; i++)
	{
		wsprintf(szString, TEXT("%4dx%4d %3dHz"), ViaDisplayRes[i].XRes, ViaDisplayRes[i].YRes, ViaDisplayRes[i].Refresh);
		rect.top += LineHeight;
		if (rect.top > 180)
		{
			rect.left += 120;
			//DrawText (hdc, TEXT ("CJ Loves You!"), -1, &rect, DT_SINGLELINE);
			rect.top = LineHeight;
		}
		DrawText (hdc, szString, -1, &rect, DT_SINGLELINE);
	}

    EndPaint (hWnd, &ps); 
}

// Windows Process Function
BOOL CALLBACK MainDialog(HWND hwndDlg,UINT msg,WPARAM wParam,LPARAM lParam)
{
    switch (msg)
    {
        case WM_INITDIALOG:  
            InitMainDialog(hwndDlg);
            return TRUE;
        case WM_PAINT:
			DoPaintMain (hwndDlg, msg, wParam, lParam);
            return TRUE;
        case WM_CLOSE:
            EndDialog(hwndDlg,0);
            return TRUE ;
    }
    
    return FALSE;
}