// Purpose:       This application is created for Test display mode
// Author:        Jasondong
// Company;       VIA Corp. Inc.
// Department:    WinCE
// Date:          2002.10.01
// Version:       1.0

#include <windows.h>
#include <winuser.h>
#include "resource.h"


typedef struct _DISPLAY_SETTINGS
{
    DWORD Width;
    DWORD Height;
    DWORD Depth;
    DWORD Freq;
} DISPLAY_SETTINGS, * PDISPLAY_SETTINGS, * LPDISPLAY_SETTINGS;
typedef DISPLAY_SETTINGS const * PCDISPLAY_SETTINGS;
typedef DISPLAY_SETTINGS const * LPCDISPLAY_SETTINGS;

typedef struct _DISPLAY_SETTINGS_2
{
    DWORD NumVGAMode;
	DWORD Width;
	DWORD Height;
	DWORD Depth;
	DWORD Freq;
} DISPLAY_SETTINGS_2, * PDISPLAY_SETTINGS_2, * LPDISPLAY_SETTINGS_2;
typedef DISPLAY_SETTINGS_2 const * PCDISPLAY_SETTINGS_2;
typedef DISPLAY_SETTINGS_2 const * LPCDISPLAY_SETTINGS_2;

typedef struct _DISPLAY_SELECTMODE
{
    TCHAR szModeName[50];
    DWORD Width;
    DWORD Height;
    DWORD Depth;
    DWORD Freq;
} DISPLAY_SELECTMODE;


// Dialog Message Process Callback Function
BOOL CALLBACK MainDialog(HWND, UINT, WPARAM, LPARAM);

void HandleMainDialogCommand(HWND hWnd, WPARAM wParam, LPARAM lParam);

void SelectDisplayMode(HWND hWnd, UINT iMode);


int WINAPI WinMain(HINSTANCE hInstance, HINSTANCE hPrevInstance, LPWSTR lpCmdLine, int nCmdShow)
{
    return DialogBox(hInstance, MAKEINTRESOURCE(IDD_DlgSetMode), NULL, MainDialog);
}

BOOL GetDisplayMode(LPDISPLAY_SETTINGS_2 lptestMode_2)
{
	HDC		hDc;
	int		iRetVal;

	//return TRUE;
	hDc = CreateDC(TEXT("DISPLAY"), NULL, NULL, NULL);

	// Make the escape call to see if queryescape is supported.
	iRetVal = ExtEscape(hDc, 0X4102,
						0,
						NULL,
						sizeof(*lptestMode_2),
						(LPSTR)lptestMode_2);
	DeleteDC(hDc);

	if (iRetVal != 1)
		return FALSE;
	return TRUE;
}

BOOL SetDisplayMode(LPDISPLAY_SETTINGS lptestMode)
{
	HDC		hDc;
	int		iRetVal;

	//return TRUE;
	hDc = CreateDC(TEXT("DISPLAY"), NULL, NULL, NULL);

	// Make the escape call to see if queryescape is supported.
	iRetVal = ExtEscape(hDc, 0X4103,
						sizeof(*lptestMode),
						(LPSTR)lptestMode,
						0,
						NULL);
	DeleteDC(hDc);

	if (iRetVal != 1)
		return FALSE;
	return TRUE;
}

void InitMainDialog(HWND hWnd)
{
    int i, nTotalVGANum;
	wchar_t psShowMode[20], psTemp[20], wch;	

	DISPLAY_SETTINGS_2 testMode_2;
	testMode_2.NumVGAMode = -1;	
	if(!GetDisplayMode(&testMode_2))
    {
        RETAILMSG(1, (TEXT("TestMode: GetDisplayMode fail\r\n")));
    }
	else
    {
		nTotalVGANum = testMode_2.NumVGAMode;
	}

    //EnableWindow(GetDlgItem(hWnd,IDC_COMBODISPMODE), FALSE);
     
    //
    //Select Display Mode
    //
    SendDlgItemMessage(hWnd, IDC_COMBODISPMODE, CB_RESETCONTENT, 0, 0); 

    for (i=0; i<nTotalVGANum; i++) {
		testMode_2.NumVGAMode = i;
		if(!GetDisplayMode(&testMode_2))
		{
			RETAILMSG(1, (TEXT("TestMode: GetDisplayMode fail\r\n")));
			return;
		}
		else
		{
			//RETAILMSG(1, (TEXT("GetVGAMode: NumVGAMode = %d, Width = %d, Height = %d, Depth = %d, Freq = %d.\r\n"), 
								//testMode_2.NumVGAMode, testMode_2.Width, testMode_2.Height, testMode_2.Depth, testMode_2.Freq));
			
			_itow((int)testMode_2.Width, psTemp, 10);
			wcscpy(psShowMode, psTemp);
			wch = 'x';
			wcscat(psShowMode, &wch);
			_itow((int)testMode_2.Height, psTemp, 10);
			wcscat(psShowMode, psTemp);
			wch = 'x';
			wcscat(psShowMode, &wch);
			_itow((int)testMode_2.Depth, psTemp, 10);
			wcscat(psShowMode, psTemp);
			wch = 'x';
			wcscat(psShowMode, &wch);
			_itow((int)testMode_2.Freq, psTemp, 10);
			wcscat(psShowMode, psTemp);
			wch = 'H';
			wcscat(psShowMode, &wch);
			wch = 'z';
			wcscat(psShowMode, &wch);
			SendDlgItemMessage(hWnd, IDC_COMBODISPMODE, CB_ADDSTRING, 0, (LPARAM)(psShowMode));
		}
    }

    SendDlgItemMessage(hWnd, IDC_COMBODISPMODE, CB_SETCURSEL, (WPARAM)0, 0);
}

// Windows Process Function
BOOL CALLBACK MainDialog(HWND hwndDlg,UINT msg,WPARAM wParam,LPARAM lParam)
{
    switch (msg)
    {
        case WM_INITDIALOG:  
            InitMainDialog(hwndDlg);
            return TRUE;
        case WM_COMMAND:
            HandleMainDialogCommand(hwndDlg, wParam, lParam);
            return TRUE;
        case WM_CLOSE:				
			 
            EndDialog(hwndDlg,0);
            return TRUE ;
    }
    
    return FALSE;
}


void HandleMainDialogCommand(HWND hWnd, WPARAM wParam, LPARAM lParam)
{
    //-----------------------------------------------------
    // Handle Command Code
    //-----------------------------------------------------
    switch(LOWORD(wParam))
    {
        ////////////////////////////////////////
        //      Mode Select
        ////////////////////////////////////////
        case IDDISPTEST:            
            SelectDisplayMode(hWnd, (UINT)SendDlgItemMessage(hWnd,IDC_COMBODISPMODE,CB_GETCURSEL, 0, 0));
            break; 

        case IDOK:  
        case IDCANCEL:
            EndDialog(hWnd, 1);
            break;
    }
}


void SelectDisplayMode(HWND hWnd, UINT iMode)
{
	DISPLAY_SETTINGS_2 testMode_2;

	testMode_2.NumVGAMode = iMode;
	if(!GetDisplayMode(&testMode_2))
	{
		RETAILMSG(1, (TEXT("TestMode: pfnGetDisplayMode fail\r\n")));
	}

    DISPLAY_SETTINGS testMode;
	    
    testMode.Width = testMode_2.Width;
    testMode.Height = testMode_2.Height;
    testMode.Depth = testMode_2.Depth;
    testMode.Freq = testMode_2.Freq;
    
    // OEM-specific code goes here.
    RETAILMSG(1, (TEXT("TestMode: Width = %d, Height = %d, Depth = %d, Freq = %d.\r\n"), testMode.Width, testMode.Height, testMode.Depth, testMode.Freq));
    
    ShowWindow(hWnd, SW_MAXIMIZE);
    
    EnableWindow(hWnd, FALSE);
    
    if (!SetDisplayMode(&testMode))
        MessageBox(hWnd, L"The display mode is not supported!", L"Error", MB_OK);

    EnableWindow(hWnd, TRUE);
    
    ShowWindow(hWnd, SW_RESTORE);
    
}
